;-------------------------------------------------------------------------------
; Call a OpenFileDialog through a MACRO
; Select an EXE file
; Run it
; Displays some stuff when back.
;-------------------------------------------------------------------------------


include \masm32\include\masm32rt.inc

; -------------------------------------------------------------------------

.data

    ConTitle  db "  ----------     **  Example running an external prog  **     ----------", 0   


    CaptionText   BYTE  "Open Prog to Run",0

    szFilter      BYTE  "All files *.*",0,"*.*",0,
                        "Executable files *.exe",0,"*.exe",0,    
                        "Text files *.txt",0,"*.txt",0,
                        "Assembly files *.asm",0,"*.asm",0,
                        "Resource files *.rc",0,"*.rc",0,0
                        
; -------------------------------------------------------------------------

 .data?

;    hFile     HANDLE ? 
    cci       CONSOLE_CURSOR_INFO <>        


    wHnd      HANDLE ? 
    rHnd      HANDLE ?

    windowSize SMALL_RECT <>
    bufferSize COORD      <>
    startPoint COORD      <>

    howmany dd ?
    buffer  INPUT_RECORD <>     

    PtrFileName   DWORD ?   

    StartUpInfo  STARTUPINFO <>
    ProcessInfo  PROCESS_INFORMATION <>     

;    hProcess     DWORD ?     

.code

start:


; -------------------------------------------------------------------------

Main PROC

    CALL   InitProc

    CALL   ConsoleSize

    print " Press any key and choose the prog to run: ",13,10,13,10

    CALL   AnyKey    

    mov PtrFileName, OpenFileDlg (0,0, addr CaptionText, addr szFilter)  

    print " The chosen prog is: "

    print DWORD PTR PtrFileName, 13,10,13,10

    print " Press a key to run it ", 13,10,13,10

    CALL   AnyKey    
    
; -------------------------------------------------------------------------
; Here we call the selected prog to run
; -------------------------------------------------------------------------


    INVOKE memfill,ADDR StartUpInfo,SIZEOF StartUpInfo,0 ; fill STARTUPINFO
    
    mov    StartUpInfo.cb,SIZEOF StartUpInfo ;

    INVOKE CreateProcess,DWORD PTR PtrFileName,0,0,0,0,0,0,0,ADDR StartUpInfo,ADDR ProcessInfo

    mov    eax,[ProcessInfo.hProcess]   ;save it for future use

    INVOKE WaitForSingleObject, eax,-1
    
; -------------------------------------------------------------------------

;    CALL   InitProc

;    CALL   ConsoleSize

;    CALL   ClearScreen

    print " Back from the called prog", 13,10,13,10

    CALL   AnyKey  

    CALL   ShowTheCursor

    INVOKE ExitProcess,0

    ret

Main ENDP

; -------------------------------------------------------------------------   

ConsoleSize PROC

    INVOKE SetConsoleTitle, ADDR ConTitle
  
    CALL   HideTheCursor

    INVOKE SetConsoleWindowInfo, wHnd, TRUE, ADDR windowSize

    INVOKE SetConsoleScreenBufferSize, wHnd, DWORD PTR bufferSize

    ret

ConsoleSize ENDP

; -------------------------------------------------------------------------

ShowTheCursor PROC

    INVOKE GetConsoleCursorInfo,wHnd,addr cci
    mov cci.bVisible,TRUE
    INVOKE SetConsoleCursorInfo,wHnd,addr cci
    ret
    
ShowTheCursor ENDP

; -------------------------------------------------------------------------
    


HideTheCursor PROC

    INVOKE GetConsoleCursorInfo,wHnd,addr cci
    mov cci.bVisible,FALSE
    INVOKE SetConsoleCursorInfo,wHnd,addr cci
    ret
    
HideTheCursor ENDP

; -------------------------------------------------------------------------

InitProc PROC

    INVOKE AllocConsole

    INVOKE GetStdHandle, STD_INPUT_HANDLE
    mov rHnd,eax

    INVOKE GetStdHandle, STD_OUTPUT_HANDLE
    mov wHnd,eax  

    mov windowSize.Left, 0
    mov windowSize.Right, 79
    mov windowSize.Top, 0
    mov windowSize.Bottom, 24
   

    mov bufferSize.x, 80
    mov bufferSize.y, 25

    mov startPoint.x, 0
    mov startPoint.y, 0


    ret

InitProc ENDP


; -------------------------------------------------------------------------
;Returns: key code in buffer.KeyEvent.wVirtualKeyCode WORD size 
; -------------------------------------------------------------------------

AnyKey PROC

again:  

    INVOKE ReadConsoleInput,rHnd,offset buffer,1,offset howmany
    cmp buffer.EventType,KEY_EVENT
    jnz again

    cmp buffer.KeyEvent.bKeyDown,0
    jz again

    ret 

AnyKey ENDP


; -------------------------------------------------------------------------

ClearScreen proc

  ; -----------------------------------------------------------
  ; This procedure reads the column and row count, multiplies
  ; them together to get the number of characters that will fit
  ; onto the screen, writes that number of blank spaces to the
  ; screen, set the screen buffer attributes and reposition
  ; the prompt at position 0,0.
  ; -----------------------------------------------------------

    LOCAL hOutPut:DWORD
    LOCAL noc    :DWORD
    LOCAL cnt    :DWORD
    LOCAL sbi    :CONSOLE_SCREEN_BUFFER_INFO

    invoke GetStdHandle,STD_OUTPUT_HANDLE
    mov hOutPut, eax

    invoke GetConsoleScreenBufferInfo,hOutPut,ADDR sbi

    mov eax, sbi.dwSize     ; 2 word values returned for screen size

  ; -----------------------------------------------
  ; extract the 2 values and multiply them together
  ; -----------------------------------------------
    mov ecx, eax
    shr eax, 16
    mul cx
    mov cnt, eax

    invoke FillConsoleOutputCharacter, hOutPut, 32, cnt, NULL, ADDR noc

    movzx ecx,sbi.wAttributes
    invoke FillConsoleOutputAttribute, hOutPut, ecx, cnt, NULL, ADDR noc

    invoke SetConsoleCursorPosition, hOutPut, NULL

    ret

ClearScreen endp


; -------------------------------------------------------------------------
  
end start           
